/**
 * @license
 * Copyright 2018 gRPC authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
import * as grpcType from '@grpc/grpc-js';
import { GrpcInterface } from './grpc_interface';
import { GcpChannelFactoryInterface } from './gcp_channel_factory';
import * as protoRoot from './generated/grpc_gcp';
import ApiConfig = protoRoot.grpc.gcp.ApiConfig;
declare const _default: (grpc: GrpcInterface) => {
    createGcpApiConfig: (apiDefinition: {}) => ApiConfig;
    gcpChannelFactoryOverride: (address: string, credentials: grpcType.ChannelCredentials, options: {}) => GcpChannelFactoryInterface;
    gcpCallInvocationTransformer: <RequestType, ResponseType>(callProperties: grpcType.CallProperties<RequestType, ResponseType>) => grpcType.CallProperties<RequestType, ResponseType>;
    GcpChannelFactory: import("./gcp_channel_factory").GcpChannelFactoryConstructor;
};
export = _default;
